
// ******************************* Programmbeispiele    Versuch 1   2015 **************************

// *************************** OHNE Optimierung bersetzen **********************************

#include <avr/io.h>       
#include <stdint.h>
#include <avr/iom16.h>			// AMTmega16
 
uint8_t n, m, o, p;				// Einige globale Variable auf Vorrat

uint16_t tod, tconv;

								// ********************  DIE FUNKTIONEN *******************



void milli (void)				// Eine Millisekunde darstellen
{

	uint16_t x;
	x= 207;

	while (x) x-- ;

return ;
}


void millisecs (uint16_t ms) 	// ms Millisekunden darstellen
{

	while (ms)
	{
		milli();
		ms--;
	}

return;
}





int main (void) 				// ******************** DAS HAUPTPROGRAMM ******************
{            

uint8_t x, y, xb, yb;					// Koordinaten

uint8_t sg[10];					// Siebensegmentanzeige

PORTA = 0xff;					// Alle Ports auf Ausgang
PORTB = 0xff;
PORTC = 0xff;
PORTD = 0xff;
DDRA  = 0xff; 
DDRB  = 0xff;
DDRC  = 0xff;
DDRD  = 0xff;                


sg[0]=0xc0;						// Siebensegmentanzeige mit Werten fllen
sg[1]=0xf9;						
sg[2]=0xa4;
sg[3]=0xb0;
sg[4]=0x99;
sg[5]=0x92;
sg[6]=0x82;
sg[7]=0xf8;
sg[8]=0x80;
sg[9]=0x90;


//							******* Hierher kommt die Initialisierung *********


//      ******** Die Endlosschleife wird durch das jeweilige Programmbeispiel ersetzt *******

//                           ******* Kopieren und einfgen *******

while (1)						// Die allgemeine Endlosschleife
{

	PORTA = ~ PORTA;			// Der erste Versuch. Messen, wie lange es dauert.	

}


return 0;
} 								// ******************** DAS ENDE ***********************



//							******** P R O G R A M M B E I S P I E L E ***********


//  ***** PROGRAMMBEISPIEL 01 ******

//  Eine Millisekunde ausmessen und einstellen

while (1)						// Die allgemeine Endlosschleife
{

milli();						// Die Millisekunde ausmessen

PORTA = ~ PORTA;				// Messen, wie lange es dauert.

}



//  ***** PROGRAMMBEISPIEL 02 ******

//  Lauflicht. Eine Richtung

while (1)						// Die allgemeine Endlosschleife
{

	n=1;

	while (n)
	{
		PORTC=~n;
		n=n<<1;
		millisecs(300);
	}


}


//  ***** PROGRAMMBEISPIEL 03 ******

//  Lauflicht. Hin und zurck.

while (1)						// Die allgemeine Endlosschleife
{

	n=1;						// Die  Vorwrtsrichtung

	while (n)
	{
		PORTC=~n;
		n=n<<1;
		millisecs(300);
	}

	n=0x40;						// Jetzt geht es zurck

	while (n!=1)				// Diese Schleife verlassen, bevor n = 1 wird
	{
		PORTC=~n;
		n=n>>1;
		millisecs(300);
	}
}


//  ***** PROGRAMMBEISPIEL 04 ******

//  Gebudesystemtechnik (1). Das elektrische Licht ein- und ausschalten.

//DDRD  = 0xff;                // Port D mu zum Eingang werden (Tasten)

while (1)						// Die allgemeine Endlosschleife
{

	while (PIND & 0x80);		// Warten, bis Taste 7 bettigt

	PORTC=~PORTC;				// Port C umschalten

	while (!(PIND & 0x80));		// Warten, bis Taste 7 losgelassen


}


//  ***** PROGRAMMBEISPIEL 05 ******

//  Gebudesystemtechnik (2). Taste entprellt.


while (1)						// Die allgemeine Endlosschleife
{

	while (PIND & 0x80);		// Warten, bis Taste 7 bettigt

	PORTC=~PORTC;				// Port C umschalten
	millisecs (10);				// Entprellen

	while (!(PIND & 0x80));		// Warten, bis Taste 7 losgelassen
	millisecs (10);				// Entprellen

}


//  ***** PROGRAMMBEISPIEL 06 ******

//  Gebudesystemtechnik (3). Sequentielles Ein- und Auschalten (Power Sequencer).

while (1)						// Die allgemeine Endlosschleife
{

	while (PIND & 0x80);		// Warten, bis Taste 7 bettigt
	millisecs (10);				// Entprellen

	while (PORTC)
	{
		millisecs (400);
		PORTC = PORTC >> 1;		// Von Bit 7 in Richtung Bit 0
		
	}

	while (!(PIND & 0x80));		// Warten, bis Taste 7 losgelassen
	millisecs (10);				// Entprellen

	while (PIND & 0x80);		// Warten, bis Taste 7 bettigt
	millisecs (10);				// Entprellen
	
	PORTC=0x01;
	while (PORTC != 0xff)
	{
		millisecs (400);
		PORTC = PORTC << 1;
		PORTC = (PORTC | 0x01);
	
	}

	while (!(PIND & 0x80));		// Warten, bis Taste 7 losgelassen
	millisecs (10);				// Entprellen	
}



//  ***** PROGRAMMBEISPIEL 07 ******

//  10.1.Siebensegmentanzeige (1). Zyklisch von 0 bis 99 zhlen

DDRB  = 0x7f;					// Ports B und C zum Abfragen der Tasten einrichten 
DDRC  = 0x7f;


while (1)						// Die allgemeine Endlosschleife
{

for (n=0; n<100; n++)			// Zhlschleife
{

PORTB = sg[n/10];				// Zehner an Port B
PORTC = sg[n%10];				// Einer an Port C
millisecs (200);				// Damit man etwas sieht
}

}


//  ***** PROGRAMMBEISPIEL 08 ******

//  10.2. Siebensegmentanzeige (2). Handzhler bis 99. 

n=0;							// Anfangswert ausgeben
PORTB = sg[n/10];
PORTC = sg[n%10];

while (1)						// Die allgemeine Endlosschleife
{

	if (!(PINB & 0x80))			// Lschtaste (links)
	{
		n=0;					// Anfangswert ausgeben
		PORTB = sg[n/10];
		PORTC = sg[n%10];
		while (!(PINB & 0x80));	// Warten auf Loslassen
	}


	if (!(PINC & 0x80))			// Zhltaste (rechts)
	{
		if (n<99) n++;			// Bei 99 anhalten
		PORTB = sg[n/10];		// ausgeben
		PORTC = sg[n%10];
		millisecs (10);			// entprellen
		while (!(PINC & 0x80));	// Warten auf Loslassen
		millisecs (10);			// entprellen
}
								// ***** Auch ohne Entprellung erproben. *****
}


//  ***** PROGRAMMBEISPIEL 09  ******

//  10.3. Siebensegmentanzeige (3). Zyklisch zhlen von 1 bis 49 (Lottozahlen). 

while (1)						// Die allgemeine Endlosschleife
{

	for (n=1; n <50; n++)
	{							// Ausgeben
		PORTB = sg[n/10];
		PORTC = sg[n%10];
		millisecs (200);		// Damit man etwas sieht
	}

}



//  ***** PROGRAMMBEISPIEL 10 ******

//  10.4. Siebensegmentanzeige (4). Lottozahlen ziehen.

while (1)						// Die allgemeine Endlosschleife
{

	for (n=1; n <50; n++)
	{							// Anfangswert ausgeben
		PORTB = sg[n/10];
		PORTC = sg[n%10];
		while ((PINC & 0x80));	// Warten auf Drcken der rechten Taste 
	}

}


//  ***** PROGRAMMBEISPIEL 11 ******

//  11.1. Tageszeituhr (1). Elementare Zeitzhlung von 00:00 bis 23.59

//  Wir zhlen Minuten. Der Tag hat 1440 Minuten.

//  Wir zhlen binr und rechnen um. Mit C knnen wir uns das leisten.

while (1)
{

	for (tod=0; tod < 1440; tod++)

	{
		tconv = tod/60;				// Stunden
		PORTA = sg [tconv/10];
		PORTD = sg [tconv%10];

		tconv = tod%60;				// Minuten
		PORTB = sg [tconv/10];
		PORTC = sg [tconv%10];

		millisecs (100);				// Zhlrhythmus
	}

}


//  ***** PROGRAMMBEISPIEL 12 ******

//  11.2. Tageszeituhr (2). Elementare Zeitzhlung von 00:00 bis 23.59

//  Die Tasten unter den Anzeigemodulen werden ausgenutzt, um den Zhltakt auszuwhlen

//  Zunchst eine Zustandsvariable definieren und die Tastenbits auf Eingabe stellen

DDRA  = 0x7f; 
DDRB  = 0x7f;
DDRC  = 0x7f;
DDRD  = 0x7f;                

uint8_t status;					// Zustandsvariable



// 		Die Tageszeituhr

status=0;						// Zustand initialisieren

while (1)						// Die allgemeine Endlosschleife
{
	
for (tod=0; tod < 1440; tod++)

	{
		tconv = tod/60;				// Stunden
		PORTA = sg [tconv/10];
		PORTD = sg [tconv%10];

		tconv = tod%60;				// Minuten
		PORTB = sg [tconv/10];
		PORTC = sg [tconv%10];

									// Den Zhlrhythmus bestimmen
		if (!(PINA&0x80)) status=0;
		if (!(PIND&0x80)) status=1;
		if (!(PINB&0x80)) status=2;
		if (!(PINC&0x80)) status=3;
	
		switch (status)				// Das jeweilige Zeitintervall auswhlen
		{

			case 0:
			{
				millisecs (1);
				break;
			}

			case 1:
			{
				millisecs(10);
				break;
			}

			case 2:
			{
				millisecs(100);
				break;
			}

			case 3:
			{
				millisecs(1000);
				break;
			}

		}


	}


}




//  ***** PROGRAMMBEISPIEL 13 ******

//  11.3. Stoppuhr (1). Zhlung von 00.00 bis 99.99 s mit 1/100 s Auflsung

//  Wir bauen erst einmal die Tageszeituhr um, um die Zhlfunktion zu prfen


status=0;						// Zustand initialisieren

while (1)						// Die allgemeine Endlosschleife
{
	
for (tod=0; tod < 9999; tod++)

	{
								// So kann jede Binrzahl in ihne dezimalen Ziffernstellen zerlegt werden:
		PORTA = sg[tod/1000]; 	tconv=tod%1000; 
		PORTD = sg[tconv/100]; 	tconv=tconv%100;
		PORTB = sg[tconv/10]; 	tconv=tconv%10;
		PORTC = sg[tconv];
									// Den Zhlrhythmus bestimmen
		if (!(PINA&0x80)) status=0;
		if (!(PIND&0x80)) status=1;
		if (!(PINB&0x80)) status=2;
		if (!(PINC&0x80)) status=3;
	
		switch (status)				// Das jeweilige Zeitintervall auswhlen
		{

			case 0:
			{
				millisecs (1);
				break;
			}

			case 1:
			{
				millisecs(10);
				break;
			}

			case 2:
			{
				millisecs(100);
				break;
			}

			case 3:
			{
				millisecs(1000);
				break;
			}

		}


	}


}






//  ***** PROGRAMMBEISPIEL 14 ******

//  11.4. Stoppuhr (2). Zhlung von 00.00 bis 99.99 s mit 1/100 s Auflsung

//  Die Taste links auen dient zum Lschen, die Taste rechts auen zum Starten und Stoppen

//  Das Programm mu auch noch die Tasten abfragen

//  Das erledigen wir mit einem Zustandsautomaten


status = 10;					// Zustand initialisieren. Ggf. auf Loslassen der Tasten warten


while (1)						// Die allgemeine Endlosschleife
{

	if (tod == 9999) status = 9; // Endstellung

	if (!(PINA & 0x80))
	{
		status = 10; tod = 0;
		millisecs (10);
	}

								// So kann jede Binrzahl in ihne dezimalen Ziffernstellen zerlegt werden:
		PORTA = sg[tod/1000]; 	tconv=tod%1000; 
		PORTD = sg[tconv/100]; 	tconv=tconv%100;
		PORTB = sg[tconv/10]; 	tconv=tconv%10;
		PORTC = sg[tconv];
	
		switch (status)				// Das jeweilige Zeitintervall auswhlen
		{

			case 0:								// Ruhe
			{
				if (!(PINC & 0x80)) status = 1;  // Taste gedrckt; Mit Zhlen anfangen
				break;
			}

			case 1:
			{
				tod++;							// Zhlen
				if (PINC & 0x80) status = 2;	// Zhlt und Taste losgelassen
				break;
			}

			case 2:
			{			
				tod++;							// Zhlen
				if (!(PINC & 0x80)) status = 3; // Zhlt und Taste wieder bettigt = anhalten
				break;
			}

			case 3:
			{
				if (PINC & 0x80) status = 0;	// Angehalten und Taste losgelassen		
				break;
			}

			case 9:
			{
				status = 10;					// Endstellung
				while (PINA & 0x80);			// Warten auf Bettigen der Lschtaste
				break;
			}

			case 10:
			{
				status = 0; tod = 0;			// Lschen oder Ende. Warten auf Loslassen der Tasten
				while (!(PINA & 0x80));			// Lschtaste losgelassen
				while (!(PINC & 0x80));			// Stoptaste losgelassen
				break;
			}

		}

		millisecs (10);

}
